MC_plot = function(s,no,days,n_plotpaths,title=""){
  # s: price processes for "no" realisations (rows) of "days" time steps (columns)
  # n_plotpaths: Number of MC-sim price paths to plot
  
  # Running means ####
  smean = s
  for (i in 1:no) {
    for (t in 2:days) {
      smean[i, t] = (t - 1) / t * smean[i, t - 1] + 1 / t * s[i, t]
    }
  }
  supermean = colMeans(smean) # Supermean (Expected path)
  # plot(density(smean[, days]), main = "mean(S_{t in [0,T]})")
  # points(mean(smean[, days]), 0)
  
  # Paths ####
  t = seq(0, T, (T / (days - 1)))
  # matplot(
  #   x = t,
  #   y = t(s[1:n_plotpaths, ]),
  #   main = noquote(paste(c(title,"Asset value"))),
  #   xlab = "Time",
  #   ylab = "Value",
  #   type = 'l'
  # )
  # lines(t,supermean,lwd=3)
  # matplot(
  #   x = t,
  #   y = t(smean[1:n_plotpaths,]),
  #   type = 'l',
  #   main = noquote(paste(c(title,"Running mean"))),
  #   ylab = "Value",
  #   xlab = "Time"
  # )
  # lines(t,supermean,lwd=3)
  
  # Compare Asset paths and Mean Paths ####
  simsToPlot = c(1:n_plotpaths)
  ylim = c(min(s[simsToPlot,]),max(s[simsToPlot,]))
  l = length(simsToPlot)
  cols = rainbow(l)
  plot(t,s[simsToPlot[1],],main=noquote(paste(c(title,"Asset and Mean path"))),xlab="Time",ylab="Value",ylim=ylim,type='l',lty='dashed',col=scales::alpha(cols[1],0.3))
  lines(t,smean[simsToPlot[1],],col=cols[1])
  if (length(simsToPlot)>1){
    colindex = 2
    for (i in simsToPlot[2:length(simsToPlot)]){
      lines(t,s[i,],lty='dashed',col=scales::alpha(cols[colindex],0.3))
      lines(t,smean[i,],col=cols[colindex])
      colindex = colindex + 1
    }
  }
  lines(t,supermean,lwd=3)
  
}