kolmogorovSmirnovTest_v2 = function(data,fittedNIG,fittedVG,fittednormal,ifPlotKS=FALSE,filename){
  # data: Data Frame containing: Time | logreturns
  # fitted...: Distributions to test the fit of (Code adapted to the specific object types of relevance)
  # ifPlotKS: if TRUE, plot cumulative distributions
  # filename: Filename of ks-plot.
  
  x = sort(data[,2])
  n = length(x)
  
  # Empirical Cumulative Distribution Function Fn(x): ####
  Fn = numeric(n)
  for(i in 1:n){
    Fn[i] = i*(1/n)
  }
  
  # Reference Cumulative Distribution F0(x): ####
  # NIG:
  Fnig = pghyp(q = x, object = fittedNIG)
  # VG:
  Fvg = pghyp(q = x, object = fittedVG)
  # Normal:
  params = coef(fittednormal)
  Fnormal = pnorm(q = x, mean = params["mean"], sd = params["sd"])
  
  Dnnig = max(abs(Fn-Fnig))
  Dnvg = max(abs(Fn-Fvg))
  Dnnormal = max(abs(Fn-Fnormal))
  
  ks = round(c(NIG = sqrt(n)*Dnnig, VG = sqrt(n)*Dnvg, Normal = sqrt(n)*Dnnormal), digits = 4)
  
  if(ifPlotKS){
    
    # pdf(file = filename, width=6, height=4)
    
    main = paste("Culumative Distributions.\n Kolmogorov-Smirnov Test - ",toupper(deparse(substitute(data))), sep = "")
    plot(x,Fvg,type='l',col="blue",main=main,xlab="log-returns",ylab="Probability")
    lines(x,Fnig, col = "red")
    lines(x,Fnormal, col = "black")
    lines(x,Fn, col = "gray")
    legend("topleft", c("Normal","VG","NIG",toupper(deparse(substitute(data)))), fill = c("black","blue","red","gray"),bty = "n")
    # dev.off()
  }
  
  return(ks)
}