# Load Data ####

# DAX
if(markets$ifdax){
dax = as.data.frame(readxl::read_excel("pricedata/DAX.xlsx", col_types = c("date","numeric")))
colnames(dax) = c("Date","Index")
dax[,1] = rev(dax[,1])
dax[,2] = rev(dax[,2])
s0dax = dax[dim(dax)[1],2]
rdax = 0.004 # Gov 10 Y Bond
dax[2:dim(dax)[1],2] = diff(log(dax[,2]), lag=1)
dax = dax[2:dim(dax)[1],]
}

# Nasdaq 100
if(markets$ifndx){
ndx = as.data.frame(readxl::read_excel("pricedata/Nasdaq100.xlsx", col_types = c("date","numeric")))
colnames(ndx) = c("Date","Index")
ndx[,1] = rev(ndx[,1])
ndx[,2] = rev(ndx[,2])
s0ndx = ndx[dim(ndx)[1],2]
rndx = 0.0291 # Gov 10 Y Bond
ndx[2:dim(ndx)[1],2] = diff(log(ndx[,2]), lag=1)
ndx = ndx[2:dim(ndx)[1],]
}

# OMX Copenhagen 20
if(markets$ifomxc){
omxc = as.data.frame(readxl::read_excel("pricedata/OMX Copenhagen20.xlsx", col_types = c("date","numeric")))
colnames(omxc) = c("Date","Index")
omxc[,1] = rev(omxc[,1])
omxc[,2] = rev(omxc[,2])
s0omxc = omxc[dim(omxc)[1],2]
romxc = 0.0039
omxc[2:dim(omxc)[1],2] = diff(log(omxc[,2]), lag=1)
omxc = omxc[2:dim(omxc)[1],]
}

# OMX Stockholm 30
if(markets$ifomxs){
omxs = as.data.frame(readxl::read_excel("pricedata/OMX Stockholm30.xlsx", col_types = c("date","numeric")))
colnames(omxs) = c("Date","Index")
omxs[,1] = rev(omxs[,1])
omxs[,2] = rev(omxs[,2])
s0omxs = omxs[dim(omxs)[1],2]
romxs = 0.0052
omxs[2:dim(omxs)[1],2] = diff(log(omxs[,2]), lag=1)
omxs = omxs[2:dim(omxs)[1],]
}

#OSEBX
if(markets$ifosebx){
osebx = as.data.frame(readxl::read_excel("pricedata/OSEBX.xlsx", col_types = c("date","numeric")))
colnames(osebx) = c("Date","Index")
osebx[,1] = rev(osebx[,1])
osebx[,2] = rev(osebx[,2])
s0osebx = osebx[dim(osebx)[1],2]
rosebx = 0.005
osebx[2:dim(osebx)[1],2] = diff(log(osebx[,2]), lag=1)
osebx = osebx[2:dim(osebx)[1],]
}

# S&P 500
if(markets$ifspx){
spx = as.data.frame(readxl::read_excel("pricedata/SPX500.xlsx", col_types = c("date","numeric")))
colnames(spx) = c("Date","Index")
spx[,1] = rev(spx[,1])
spx[,2] = rev(spx[,2])
s0spx = spx[dim(spx)[1],2]
rspx = 0.0291 # Gov 10 Y Bond
spx[2:dim(spx)[1],2] = diff(log(spx[,2]), lag=1)
spx = spx[2:dim(spx)[1],]
}