clear all;
clc;
initialiseAndGetParams;
overall_runtime = tic;

gridsizes = 2.^[8 9 10 11 12];
strikes = [0.99*strike, strike, 1.01*strike];

%% Pricing
gbmpiprices = zeros(length(strikes)+2, length(gridsizes)+1); % Gridsizes along columns, strikes along rows
[rows,cols] = size(gbmpiprices);
gbmpiprices(:,1) = [0, strikes, 0];
gbmpiprices(1,:) = [0, gridsizes];
for c = 2:(cols-1)
    pi_time = tic;
    gbmpiprices(2:(length(strikes)+1),c) = pi_fft_asian_gbm(s0,strikes,sd,r,q,T,dt,gridsizes(c-1)); % y-limits set for DAX
    gbmpiprices(length(strikes)+2,c) = toc(pi_time);
    fprintf("PI - GBM:\n Gridsize: %i, strike: %i, result: %d, runtime: %d \n",gridsizes(c-1),strike,gbmpiprices(round(rows/2),c),gbmpiprices(rows,c));
end

nigpiprices = zeros(length(strikes)+2, length(gridsizes)+1); % Gridsizes along columns, strikes along rows
[rows,cols] = size(nigpiprices);
nigpiprices(:,1) = [0, strikes, 0];
nigpiprices(1,:) = [0, gridsizes];
for c = 2:cols
    pi_time = tic;
    nigpiprices(2:(length(strikes)+1),c) = pi_fft_asian_nig(s0,strikes,alpha,delta,beta,munig,r,q,T,dt,gridsizes(c-1));
    nigpiprices(length(strikes)+2,c) = toc(pi_time);
    fprintf("PI - NIG:\n Gridsize: %i, strike: %i, result: %d, runtime: %d \n",gridsizes(c-1),strike,nigpiprices(round(rows/2),c),nigpiprices(rows,c));
end

vgpiprices = zeros(length(strikes)+2, length(gridsizes)+1); % Gridsizes along columns, strikes along rows
[rows,cols] = size(vgpiprices);
vgpiprices(:,1) = [0, strikes, 0];
vgpiprices(1,:) = [0, gridsizes];
for c = 2:cols
    pi_time = tic;
    vgpiprices(2:(length(strikes)+1),c) = pi_fft_asian_vg(s0,strikes,sigma,lambda,vggamma,muvg,r,q,T,dt,gridsizes(c-1));
    vgpiprices(length(strikes)+2,c) = toc(pi_time);
    fprintf("PI - VG:\n Gridsize: %i, strike: %i, result: %d, runtime: %d \n",gridsizes(c-1),strike,vgpiprices(round(rows/2),c),vgpiprices(rows,c));
end

%% Saving Results
overall_runtime = toc(overall_runtime);
xlswrite('gbmpiprices.xlsx',gbmpiprices);
xlswrite('nigpiprices.xlsx',nigpiprices);
xlswrite('nigpiprices_corrected.xlsx',nigpiprices_corrected);
xlswrite('vgpiprices.xlsx',vgpiprices);
xlswrite('vgpiprices_unsmoothed.xlsx',vgpiprices_unsmoothed);