# Set Working Directory
setwd("C:/Users/marku/Dropbox/Master/Code")
# setwd("D:/Dokumenter/Dropbox/Master/Code")

ifPlot = FALSE
ifTest = FALSE
ifPlotKS = FALSE
ifPlotMC = FALSE
markets = data.frame(t(c(
            ifdax   = 1, # Markets to load data from and fit models to
            ifndx   = 0,
            ifomxc  = 0,
            ifomxs  = 0,
            ifosebx = 0,
            ifspx   = 0)))
source("initialise.R") # Setting parameters, loading data and fitting distributions

# Choose Market #### (Can for-loop over all markets, but I restrict to one)
params = daxParams
# params = osebxParams
# params = ndxParams
# params = omxcParams
# params = omxsParams
# params = spxParams
params$GLOBAL$riskfreeRate = 1/250*params$GLOBAL$riskfreeRate # From yearly to daily rate
strikes = c(0.99*params$GLOBAL$strike, params$GLOBAL$strike, 1.01*params$GLOBAL$strike)
# source("exportParams.R")

# Price by MC ####
T = 50 # 2.4 months
no = 1000000 # Number of MC simulations
mcruns = 100 # Number of MC runs (to make CI)
simprices_strikes = list(NIG = matrix(0,nrow=length(strikes), ncol = mcruns), VG = matrix(0,nrow=length(strikes), ncol = mcruns), GBM = matrix(0,nrow=length(strikes), ncol = mcruns))

for (i in 1:mcruns){
  MC = asianMC_strikes(params,strikes,q,T,dt,no,ifPlotMC,n_plotpaths)
  simprices_strikes$NIG[,i] = MC$prices$NIG_price
  simprices_strikes$VG[,i] = MC$prices$VG_price
  simprices_strikes$GBM[,i] = MC$prices$GBM_price
  print(noquote(paste("Completed MC run number ",i)))
}

mean_strikes_nig = rowMeans(simprices_strikes$NIG)
sd_strikes_nig = numeric(length=length(strikes))
for (i in 1:length(strikes)){
  sd_strikes_nig[i] = sd(simprices_strikes$NIG[i,])
}
mean_strikes_vg = rowMeans(simprices_strikes$VG)
sd_strikes_vg = numeric(length=length(strikes))
for (i in 1:length(strikes)){
  sd_strikes_vg[i] = sd(simprices_strikes$VG[i,])
}
mean_strikes_gbm = rowMeans(simprices_strikes$GBM)
sd_strikes_gbm = numeric(length=length(strikes))
for (i in 1:length(strikes)){
  sd_strikes_gbm[i] = sd(simprices_strikes$GBM[i,])
}

simprices_strikes$NIG = data.frame(matrix(c(mean_strikes_nig,mean_strikes_nig-1.96*sd_strikes_nig,mean_strikes_nig+1.96*sd_strikes_nig), nrow = length(strikes)))
colnames(simprices_strikes$NIG) = c("MC","CI_l","CI_u")
rownames(simprices_strikes$NIG) = strikes

simprices_strikes$VG = data.frame(matrix(c(mean_strikes_vg,mean_strikes_vg-1.96*sd_strikes_vg,mean_strikes_vg+1.96*sd_strikes_vg), nrow = length(strikes)))
colnames(simprices_strikes$VG) = c("MC","CI_l","CI_u")
rownames(simprices_strikes$VG) = strikes

simprices_strikes$GBM = data.frame(matrix(c(mean_strikes_gbm,mean_strikes_gbm-1.96*sd_strikes_gbm,mean_strikes_gbm+1.96*sd_strikes_gbm), nrow = length(strikes)))
colnames(simprices_strikes$GBM) = c("MC","CI_l","CI_u")
rownames(simprices_strikes$GBM) = strikes